
Redmine - Defect #35927

Slow loading of /time_entries/new

2021-09-28 13:05 - Mark J

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Go MAEDA % Done: 0%

Category: Performance Estimated time: 0.00 hour

Target version: 6.1.0   

Resolution: Fixed Affected version: 4.2.1

Description

Opening /time_entries/new takes 10s, when we have 1000 users with 2 different groups that one has ~10 users and other has all

other users.

I have looked into code and it seems I have found the issue, attaching additional info via screens. Basically if project has a lot of

users `assignable_users` enumerates each users permissions by one, creating 2*X (X=number users) sql queries.

I'm hosting redmine with help of docker official image.

Environment:

Redmine version                4.2.1.stable

Ruby version                   2.7.4-p191 (2021-07-07) [x86_64-linux]

Rails version                  5.2.5

Environment                    debug

Database adapter               SQLServer

Mailer queue                   ActiveJob::QueueAdapters::AsyncAdapter

Mailer delivery                smtp

SCM:

Subversion                     1.10.4

Mercurial                      4.8.2

Bazaar                         2.8.0

Git                            2.20.1

Filesystem

Redmine plugins:

no plugin installed

Associated revisions

Revision 23595 - 2025-04-02 11:22 - Go MAEDA

Improve performance of `TimeEntry#assignable_users` by reducing SQL queries (#35927).

Patch by Go MAEDA (user:maeda).

History

#1 - 2021-10-03 07:41 - Marius BĂLTEANU

- Status changed from New to Confirmed

- Assignee set to Marius BĂLTEANU

#2 - 2025-02-02 14:09 - Go MAEDA

- File 35927.patch added

- Target version set to Candidate for next minor release

The attached patch should fixes the issue.

Below are the results tested on a project with 7 members.

Current code:

redmine-app(dev)> t = TimeEntry.first

  TimeEntry Load (0.1ms)  SELECT "time_entries".* FROM "time_entries" ORDER BY "time_entries"."id" ASC LIMIT ?

  [["LIMIT", 1]]
=> 

#<TimeEntry:0x000000016c1f2df0

...

redmine-app(dev)> t.assignable_users

  Project Load (0.1ms)  SELECT "projects".* FROM "projects" WHERE "projects"."id" = ? LIMIT ?  [["id", 1], ["L

IMIT", 1]]

  Member Load (0.1ms)  SELECT "members".* FROM "members" INNER JOIN "users" ON "users"."id" = "members"."user_

id" WHERE "members"."project_id" = ? AND "users"."type" = ? AND "users"."status" = ? AND "users"."status" = ? 

 [["project_id", 1], ["type", "User"], ["status", 1], ["status", 1]]

  User Load (0.1ms)  SELECT "users".* FROM "users" WHERE "users"."type" = ? AND "users"."id" IN (?, ?, ?, ?, ?

, ?, ?)  [["type", "User"], ["id", 2], ["id", 3], ["id", 1], ["id", 4], ["id", 7], ["id", 8], ["id", 9]]

  EnabledModule Pluck (0.4ms)  SELECT "enabled_modules"."name" FROM "enabled_modules" WHERE "enabled_modules".

"project_id" = ?  [["project_id", 1]]

  Member Load (0.1ms)  SELECT "members".* FROM "members" INNER JOIN "projects" ON "projects"."id" = "members".

"project_id" WHERE "members"."user_id" = ? AND "projects"."status" != ? AND "members"."project_id" = ? ORDER B

Y "members"."id" ASC LIMIT ?  [["user_id", 2], ["status", 9], ["project_id", 1], ["LIMIT", 1]]

  Role Load (0.1ms)  SELECT DISTINCT "roles".* FROM "roles" INNER JOIN "member_roles" ON "roles"."id" = "membe

r_roles"."role_id" WHERE "member_roles"."member_id" = ?  [["member_id", 1]]

  Member Load (0.2ms)  SELECT "members".* FROM "members" INNER JOIN "projects" ON "projects"."id" = "members".

"project_id" WHERE "members"."user_id" = ? AND "projects"."status" != ? AND "members"."project_id" = ? ORDER B

Y "members"."id" ASC LIMIT ?  [["user_id", 3], ["status", 9], ["project_id", 1], ["LIMIT", 1]]

  Role Load (0.0ms)  SELECT DISTINCT "roles".* FROM "roles" INNER JOIN "member_roles" ON "roles"."id" = "membe

r_roles"."role_id" WHERE "member_roles"."member_id" = ?  [["member_id", 2]]

  Member Load (0.0ms)  SELECT "members".* FROM "members" INNER JOIN "projects" ON "projects"."id" = "members".

"project_id" WHERE "members"."user_id" = ? AND "projects"."status" != ? AND "members"."project_id" = ? ORDER B

Y "members"."id" ASC LIMIT ?  [["user_id", 4], ["status", 9], ["project_id", 1], ["LIMIT", 1]]

  Role Load (0.0ms)  SELECT DISTINCT "roles".* FROM "roles" INNER JOIN "member_roles" ON "roles"."id" = "membe

r_roles"."role_id" WHERE "member_roles"."member_id" = ?  [["member_id", 38]]

  Member Load (0.0ms)  SELECT "members".* FROM "members" INNER JOIN "projects" ON "projects"."id" = "members".

"project_id" WHERE "members"."user_id" = ? AND "projects"."status" != ? AND "members"."project_id" = ? ORDER B

Y "members"."id" ASC LIMIT ?  [["user_id", 7], ["status", 9], ["project_id", 1], ["LIMIT", 1]]

  Role Load (0.0ms)  SELECT DISTINCT "roles".* FROM "roles" INNER JOIN "member_roles" ON "roles"."id" = "membe

r_roles"."role_id" WHERE "member_roles"."member_id" = ?  [["member_id", 39]]

  Member Load (0.0ms)  SELECT "members".* FROM "members" INNER JOIN "projects" ON "projects"."id" = "members".

"project_id" WHERE "members"."user_id" = ? AND "projects"."status" != ? AND "members"."project_id" = ? ORDER B

Y "members"."id" ASC LIMIT ?  [["user_id", 8], ["status", 9], ["project_id", 1], ["LIMIT", 1]]

  Role Load (0.0ms)  SELECT DISTINCT "roles".* FROM "roles" INNER JOIN "member_roles" ON "roles"."id" = "membe

r_roles"."role_id" WHERE "member_roles"."member_id" = ?  [["member_id", 40]]

  Member Load (0.0ms)  SELECT "members".* FROM "members" INNER JOIN "projects" ON "projects"."id" = "members".

"project_id" WHERE "members"."user_id" = ? AND "projects"."status" != ? AND "members"."project_id" = ? ORDER B

Y "members"."id" ASC LIMIT ?  [["user_id", 9], ["status", 9], ["project_id", 1], ["LIMIT", 1]]

  Role Load (0.0ms)  SELECT DISTINCT "roles".* FROM "roles" INNER JOIN "member_roles" ON "roles"."id" = "membe

r_roles"."role_id" WHERE "member_roles"."member_id" = ?  [["member_id", 41]]

  AnonymousUser Load (0.1ms)  SELECT "users".* FROM "users" WHERE "users"."type" = ? AND "users"."lastname" = 

? LIMIT ?  [["type", "AnonymousUser"], ["lastname", "Anonymous"], ["LIMIT", 1]]

 With the patch applied:

redmine-app(dev)> t = TimeEntry.first

  TimeEntry Load (0.4ms)  SELECT "time_entries".* FROM "time_entries" ORDER BY "time_entries"."id" ASC LIMIT ?

  [["LIMIT", 1]]

=> 

#<TimeEntry:0x000000030b457f00

...

redmine-app(dev)> t.assignable_users

  Project Load (0.4ms)  SELECT "projects".* FROM "projects" WHERE "projects"."id" = ? LIMIT ?  [["id", 1], ["L

IMIT", 1]]

  Member Load (0.3ms)  SELECT "members".* FROM "members" INNER JOIN "users" ON "users"."id" = "members"."user_

id" WHERE "members"."project_id" = ? AND "users"."type" = ? AND "users"."status" = ? AND "users"."status" = ? 

 [["project_id", 1], ["type", "User"], ["status", 1], ["status", 1]]

  MemberRole Load (0.1ms)  SELECT "member_roles".* FROM "member_roles" WHERE "member_roles"."member_id" IN (?,

 ?, ?, ?, ?, ?, ?)  [["member_id", 1], ["member_id", 2], ["member_id", 37], ["member_id", 38], ["member_id", 3

9], ["member_id", 40], ["member_id", 41]]

  Role Load (0.1ms)  SELECT DISTINCT "roles".* FROM "roles" WHERE "roles"."id" IN (?, ?)  [["id", 1], ["id", 2

]]

  User Load (0.1ms)  SELECT "users".* FROM "users" WHERE "users"."type" = ? AND "users"."id" IN (?, ?, ?, ?, ?

, ?, ?)  [["type", "User"], ["id", 2], ["id", 3], ["id", 1], ["id", 4], ["id", 7], ["id", 8], ["id", 9]]

  AnonymousUser Load (0.1ms)  SELECT "users".* FROM "users" WHERE "users"."type" = ? AND "users"."lastname" = 

? LIMIT ?  [["type", "AnonymousUser"], ["lastname", "Anonymous"], ["LIMIT", 1]]

#3 - 2025-02-05 08:35 - Go MAEDA

- Target version changed from Candidate for next minor release to 5.1.7

2025-05-01 2/3



Setting the target version to 5.1.7.

#4 - 2025-02-09 08:24 - Go MAEDA

- File 35927-v2.patch added

I have updated the patch to properly sort users.

#5 - 2025-03-02 08:28 - Go MAEDA

- Target version changed from 5.1.7 to 5.1.8

#6 - 2025-03-29 14:45 - Marius BĂLTEANU

- Assignee changed from Marius BĂLTEANU to Go MAEDA

#7 - 2025-04-02 11:23 - Go MAEDA

- Status changed from Confirmed to Closed

- Target version changed from 5.1.8 to 6.1.0

- Resolution set to Fixed

Committed the patch in r23595.

#8 - 2025-04-15 08:13 - Go MAEDA

- Category changed from Time tracking to Performance

Files
